<?php
	//Find-Monitoring Version 0.2 with ABM

	//if($_SERVER['REMOTE_ADDR'] != '31.220.4.174') die('Error (code 1)'); // The find-xss.net IP
	$password = ""; // Enter your Find-Monitoring password
	$extensions = array("php", "php3", "phtml", "pl", "py", "rb", "inc", "js"); // Enter the file extensions for monitoring
	$including_files = array(".htaccess", "robots.txt"); // Including files for monitoring
	$excluding_files = array(".", "..", "cache", "templates_c", "error.php"); // Excluding files or folders from monitoring ((".", "..") - require)
	$ismd5 = true; //Enable md5 hash: true, or disable: false

	// Files data colculation
	function scanDirectories($rootDir, $allFiles=array()) {
		global $extensions, $including_files, $excluding_files, $ismd5;
		// run through content of root directory
		$dirContent = scandir($rootDir);
		foreach($dirContent as $key => $content) {
			// filter all files not accessible
			$path = $rootDir.'/'.$content;
			if(!in_array($content, $excluding_files)) {
				// if content is file & readable, add to array
				$type = explode(".", $content);
				if(is_file($path) && is_readable($path) && (in_array(end($type), $extensions) || in_array($content, $including_files))) {
					// get file data
					$currentmd5 = $ismd5 ? strtolower(md5(file_get_contents($path))) : "0";
					$data = array("n" => $path, "p" => substr(sprintf('%o', fileperms($path)), -4), "s" => filesize($path), "d" => filemtime($path), "m" => $currentmd5);
					// save file name with path
					$allFiles[] = $data;
				// if content is a directory and readable, add path and name
				} else if(!is_link($path) && is_dir($path) && is_readable($path)) {
					// recursive callback to open new directory
					$allFiles = scanDirectories($path, $allFiles);
				}
			}
		}
		return $allFiles;
	}

	// Encoding
	function base64_url_encode($input) {
		return strtr(base64_encode(fxn_encrypt($input)), '+/=', '-_,');
	}

	// Encrypting
	function encrypt($text) {
		return fxn_encrypt($text);
		//return mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $password, $text, MCRYPT_MODE_ECB, mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND));
	}


	function fxn_encrypt($plaintext){
		global $password;
		$ivlen = openssl_cipher_iv_length($cipher="AES-128-CBC");
		$iv = openssl_random_pseudo_bytes($ivlen);
		$ciphertext_raw = openssl_encrypt($plaintext, $cipher, $password, $options=OPENSSL_RAW_DATA, $iv);
		$hmac = hash_hmac('sha256', $ciphertext_raw, $password, $as_binary=true);
		$ciphertext = base64_encode( $iv.$hmac.$ciphertext_raw );
		return $ciphertext;
	}

	// Get data
	$files = scanDirectories(".");

	//Sort
	sort($files);

	// Create md5 hash
	$answer = $password."::".serialize($files);
	$md5 = strtolower(md5($answer));

	// Check and output answer
	if(!isset($_GET['req'])) {
		echo "Error (code 2)";
	} else if(strtolower($_GET['req']) != $md5) {
	     //Access point
        define("_BOARD_VALID_", 1);

        require_once(dirname(__FILE__)."/autobackupmaster/stop.php");
		echo base64_url_encode($answer);
	} else {
		echo $md5;
	}
?>
